//=============================================================================
// Parent Class.
//=============================================================================
class RifleFeed extends CraftingFeed abstract;

#exec TEXTURE IMPORT FILE="Textures\FeedBeltGreen.pcx"	NAME="FeedBeltGreen"	GROUP="Skins" MIPS=Off
#exec TEXTURE IMPORT FILE="Textures\FeedGray50.pcx"	NAME="FeedGray50"	GROUP="Skins" MIPS=Off
#exec TEXTURE IMPORT FILE="Textures\FeedGray60.pcx"	NAME="FeedGray60"	GROUP="Skins" MIPS=Off
#exec TEXTURE IMPORT FILE="Textures\FeedGray80.pcx"	NAME="FeedGray80"	GROUP="Skins" MIPS=Off
#exec TEXTURE IMPORT FILE="Textures\TippingBrown.pcx"	NAME="FeedBrown"	GROUP="Skins" MIPS=Off
#exec TEXTURE IMPORT FILE="Textures\CasingGold.pcx"	NAME="FeedGold"	GROUP="Skins" MIPS=Off

//==================
//10 Shot Mag
//==================
#exec MESH IMPORT MESH=10ShotMag ANIVFILE=MODELS\10ShotMag_a.3d DATAFILE=MODELS\10ShotMag_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=10ShotMag X=0 Y=0 Z=0 PITCH=0 ROLL=0 YAW=0

#exec MESH SEQUENCE MESH=10ShotMag SEQ=All              STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=10ShotMag SEQ=10ShotMag STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW   MESHMAP=10ShotMag MESH=10ShotMag
#exec MESHMAP SCALE MESHMAP=10ShotMag X=0.01375044 Y=-0.01375044 Z=0.01375044

#exec MESHMAP SETTEXTURE MESHMAP=10ShotMag NUM=0 TEXTURE=FeedGray50
#exec MESHMAP SETTEXTURE MESHMAP=10ShotMag NUM=1 TEXTURE=FeedGold
#exec MESHMAP SETTEXTURE MESHMAP=10ShotMag NUM=2 TEXTURE=FeedBrown

//==================
//20 Shot Mag
//==================
#exec MESH IMPORT MESH=20ShotMag ANIVFILE=MODELS\20ShotMag_a.3d DATAFILE=MODELS\20ShotMag_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=20ShotMag X=0 Y=0 Z=0 PITCH=0 ROLL=0 YAW=0

#exec MESH SEQUENCE MESH=20ShotMag SEQ=All              STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=20ShotMag SEQ=20ShotMag STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW   MESHMAP=20ShotMag MESH=20ShotMag
#exec MESHMAP SCALE MESHMAP=20ShotMag X=0.011000352 Y=-0.011000352 Z=0.011000352

#exec MESHMAP SETTEXTURE MESHMAP=20ShotMag NUM=0 TEXTURE=FeedGray60
#exec MESHMAP SETTEXTURE MESHMAP=20ShotMag NUM=1 TEXTURE=FeedGold
#exec MESHMAP SETTEXTURE MESHMAP=20ShotMag NUM=2 TEXTURE=FeedBrown

//==================
//30 Shot Mag
//==================
#exec MESH IMPORT MESH=30ShotMag ANIVFILE=MODELS\30ShotMag_a.3d DATAFILE=MODELS\30ShotMag_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=30ShotMag X=0 Y=0 Z=0 PITCH=0 ROLL=0 YAW=0

#exec MESH SEQUENCE MESH=30ShotMag SEQ=All              STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=30ShotMag SEQ=30ShotMag STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW   MESHMAP=30ShotMag MESH=30ShotMag
#exec MESHMAP SCALE MESHMAP=30ShotMag X=0.011000352 Y=-0.011000352 Z=0.011000352

#exec MESHMAP SETTEXTURE MESHMAP=30ShotMag NUM=0 TEXTURE=FeedGray80
#exec MESHMAP SETTEXTURE MESHMAP=30ShotMag NUM=1 TEXTURE=FeedGold
#exec MESHMAP SETTEXTURE MESHMAP=30ShotMag NUM=2 TEXTURE=FeedBrown


//==================
//100 Shot Mag
//==================
#exec MESH IMPORT MESH=100ShotMag ANIVFILE=MODELS\100ShotMag_a.3d DATAFILE=MODELS\100ShotMag_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=100ShotMag X=0 Y=0 Z=0 PITCH=0 ROLL=0 YAW=0

#exec MESH SEQUENCE MESH=100ShotMag SEQ=All              STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=100ShotMag SEQ=100ShotMag STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW   MESHMAP=100ShotMag MESH=30ShotMag
#exec MESHMAP SCALE MESHMAP=100ShotMag X=0.0126504048 Y=-0.0126504048 Z=0.0126504048

#exec MESHMAP SETTEXTURE MESHMAP=100ShotMag NUM=0 TEXTURE=FeedGray80
#exec MESHMAP SETTEXTURE MESHMAP=100ShotMag NUM=1 TEXTURE=FeedGold
#exec MESHMAP SETTEXTURE MESHMAP=100ShotMag NUM=2 TEXTURE=FeedBrown
#exec MESHMAP SETTEXTURE MESHMAP=100ShotMag NUM=3 TEXTURE=FeedBeltGreen

var Texture Multi4;
var Mesh PickupMesh, ThirdMesh, FirstMesh;

defaultproperties
{
 PickupMesh=LODMesh'AK47PickupMag'
 ThirdMesh=LODMesh'AK473rdMag'
 FirstMesh=LODMesh'AK471stMag'
}
