//=============================================================================
// WorkBenchMenuMain
//=============================================================================

class WorkBenchMenuMain expands MenuUIWindow;

//Universals
var DeusExPlayer Player;
var PartsBag Bench;
var MSMassEffectMutator Mutator;

//Window Specifics
var MenuUIActionButtonWindow exitButton;
var localized string exitButtonText;

var PersonaActionButtonWindow CraftButtons[4];
var localized string ButtonNames[4];
var int PosX[4];
var int PosY[4];

var Window Last;

// ----------------------------------------------------------------------
// InitWindow()
//
// Initialize the Window... it's way down there...
// In the meantime, here's a lot of precautionary vomit!
// ----------------------------------------------------------------------


function bool CanPushScreen(Class <DeusExBaseWindow> newScreen)
{
 return false;
}

function bool CanStack()
{
 return false;
}

event bool VirtualKeyPressed(EInputKey key, bool bRepeat)
{
 /*if (key == IK_M)
  {
   TNMDreamScapePlayer(Ralph.Owner).ShowImagesWindow();
   return true;
  }*/
 return false;
}

event bool RawKeyPressed(EInputKey key, EInputState iState, bool bRepeat)
{
 /*if (key == IK_M)
  {
   TNMDreamScapePlayer(Ralph.Owner).ShowImagesWindow();
   return true;
  }*/
 return false;
}

event InitWindow()
{
 local int i, j;

	Super.InitWindow();
        SetTitle("Select Bench Mode");
        exitButton = winButtonBar.AddButton(exitButtonText, HALIGN_Left);

       for (i=0; i<4; i++)
       {
	CraftButtons[i] = PersonaActionButtonWindow(NewChild(Class'PersonaActionButtonWindow'));
	CraftButtons[i].SetPos(PosX[i], PosY[i]);
	CraftButtons[i].SetButtonText(ButtonNames[i]);
       }

}

function UpdateInfo()
{
}

function bool ButtonActivated( Window buttonPressed )
{
	local bool bHandled;
	local name TempName;

	bHandled = True;

	Super.ButtonActivated(buttonPressed);

	switch(buttonPressed)
	{
		case exitButton:
			//Ralph.ChargeTheGates(TempName);
			// Do stuff

			Last.Show(True);
			PartDisplayWindow(Last).ResetList();

			root.PopWindow();
			bHandled = True;
			break;

		case CraftButtons[0]:
			InvokeCraftScreen();
			bHandled = True;
			break;
		case CraftButtons[1]:
			InvokeRepairScreen();
			bHandled = True;
			break;
		case CraftButtons[2]:
			InvokeBreakdownScreen();
			bHandled = True;
			break;
		case CraftButtons[3]:
			InvokeEquipScreen();
			bHandled = True;
			break;

		default:
			bHandled = False;
			break;
	}

	if (ButtonPressed != exitButton)
	{
		UpdateInfo();
	}

	return bHandled;
}

function InvokeRepairScreen()
{
	local WorkBenchMenuRepairMain newRep;
	
	newRep = WorkBenchMenuRepairMain(root.InvokeMenuScreen(Class'WorkBenchMenuRepairMain'));
	
	if (newRep != None)
	{
		newRep.Player = Player;
		newRep.Bench = Bench;
		newRep.Mutator = Mutator;
		
		newRep.Last = Self;
		Show(False);
	}
}

function InvokeBreakdownScreen()
{
	local WorkBenchMenuBreakdownMain newBreak;
	
	newBreak = WorkBenchMenuBreakdownMain(root.InvokeMenuScreen(Class'WorkBenchMenuBreakdownMain'));
	
	if (newBreak != None)
	{
		newBreak.Player = Player;
		newBreak.Bench = Bench;
		newBreak.Mutator = Mutator;
		
		newBreak.Last = Self;
		Show(False);
	}
}

function InvokeCraftScreen()
{
	local WorkBenchMenuCraftMain newCraft;
	
	newCraft = WorkBenchMenuCraftMain(root.InvokeMenuScreen(Class'WorkBenchMenuCraftMain'));
	
	if (newCraft != None)
	{
		newCraft.Player = Player;
		newCraft.Bench = Bench;
		newCraft.Mutator = Mutator;
		
		newCraft.Last = Self;
		Show(False);
	}
}

function InvokeEquipScreen()
{
	local WorkBenchMenuEquipMain newEquip;
	
	newEquip = WorkBenchMenuEquipMain(root.InvokeMenuScreen(Class'WorkBenchMenuEquipMain'));
	
	if (newEquip != None)
	{
		newEquip.Player = Player;
		newEquip.Bench = Bench;
		newEquip.Mutator = Mutator;
		
		newEquip.Last = Self;
		Show(False);
	}
}

defaultproperties
{
     PosX(0)=22
     PosX(1)=153
     PosX(2)=22
     PosX(3)=153
     PosY(0)=32
     PosY(1)=32
     PosY(2)=68
     PosY(3)=68
     ButtonNames(0)="Craft"
     ButtonNames(1)="Repair"
     ButtonNames(2)="Break-Down"
     ButtonNames(3)="Equip"
     Title="Select Bench Mode"
     exitButtonText="Done"
     ClientWidth=350
     ClientHeight=100
     clientTextures(0)=Texture'DeusExUI.UserInterface.MenuMessageBoxBackground_1'
     clientTextures(1)=Texture'DeusExUI.UserInterface.MenuMessageBoxBackground_2'
     textureRows=1
     textureCols=2
     bActionButtonBarActive=True
     bUsesHelpWindow=False
     exitButtonText="Done"
     ScreenType=ST_Persona
}
