//=============================================================================
// WorkBenchMenuMain
//=============================================================================

class WorkBenchMenuRepairMain expands MenuUIWindow;

//Universals
var DeusExPlayer Player;
var PartsBag Bench;
var MSMassEffectMutator Mutator;

//Window Specifics
var MenuUIActionButtonWindow exitButton;
var localized string exitButtonText;

var PersonaActionButtonWindow CraftButtons[4];
var localized string ButtonNames[4];
var int PosX[4];
var int PosY[4];

var Window Last;

// ----------------------------------------------------------------------
// InitWindow()
//
// Initialize the Window... it's way down there...
// In the meantime, here's a lot of precautionary vomit!
// ----------------------------------------------------------------------


function bool CanPushScreen(Class <DeusExBaseWindow> newScreen)
{
 return false;
}

function bool CanStack()
{
 return false;
}

event bool VirtualKeyPressed(EInputKey key, bool bRepeat)
{
 /*if (key == IK_M)
  {
   TNMDreamScapePlayer(Ralph.Owner).ShowImagesWindow();
   return true;
  }*/
 return false;
}

event bool RawKeyPressed(EInputKey key, EInputState iState, bool bRepeat)
{
 /*if (key == IK_M)
  {
   TNMDreamScapePlayer(Ralph.Owner).ShowImagesWindow();
   return true;
  }*/
 return false;
}

event InitWindow()
{
 local int i, j;

	Super.InitWindow();
        SetTitle("Select Repair Type");
        exitButton = winButtonBar.AddButton(exitButtonText, HALIGN_Left);

       for (i=0; i<2; i++)
       {
	CraftButtons[i] = PersonaActionButtonWindow(NewChild(Class'PersonaActionButtonWindow'));
	CraftButtons[i].SetPos(PosX[i], PosY[i]);
	CraftButtons[i].SetButtonText(ButtonNames[i]);
       }

}

function UpdateInfo()
{
}

function bool ButtonActivated( Window buttonPressed )
{
	local bool bHandled;
	local name TempName;

	bHandled = True;

	Super.ButtonActivated(buttonPressed);

	switch(buttonPressed)
	{
		case exitButton:
			//Ralph.ChargeTheGates(TempName);
			// Do stuff
			Last.Show(True);

			root.PopWindow();
			bHandled = True;
			break;

		case CraftButtons[0]:
			InvokeWeaponRepairScreen();
			bHandled = True;
			break;
		case CraftButtons[1]:
			InvokePartRepairScreen();
			bHandled = True;
			break;
		/*case CraftButtons[2]:
			InvokePartRepairScreen();
			bHandled = True;
			break;*/
		/*case CraftButtons[3]:
			InvokeBreakdownScreen();
			bHandled = True;
			break;*/

		default:
			bHandled = False;
			break;
	}

	if (ButtonPressed != exitButton)
	{
		UpdateInfo();
	}

	return bHandled;
}

function InvokeWeaponRepairScreen()
{
	local WorkBenchMenuRepairWeapon newWep;
	
	newWep = WorkBenchMenuRepairWeapon(root.InvokeMenuScreen(Class'WorkBenchMenuRepairWeapon'));
	
	if (newWep != None)
	{
		newWep.Player = Player;
		newWep.Bench = Bench;
		newWep.Mutator = Mutator;
		
		newWep.Last = Self;
		Show(False);
	}
}

function InvokePartRepairScreen()
{
	local WorkBenchMenuRepairPart newPart;
	
	newPart = WorkBenchMenuRepairPart(root.InvokeMenuScreen(Class'WorkBenchMenuRepairPart'));
	
	if (newPart != None)
	{
		newPart.Player = Player;
		newPart.Bench = Bench;
		newPart.Mutator = Mutator;
		newPart.ForwardPart();
		
		newPart.Last = Self;
		Show(False);
	}
}

defaultproperties
{
     PosX(0)=22
     PosX(1)=153
     PosX(2)=22
     PosX(3)=153
     PosY(0)=32
     PosY(1)=32
     PosY(2)=68
     PosY(3)=68
     ButtonNames(0)="Weapon"
     ButtonNames(1)="Part"
     ButtonNames(2)="Part ERR"
     ButtonNames(3)="Part ERRD"
     Title="Select Repair Type"
     exitButtonText="Done"
     ClientWidth=350
     ClientHeight=100
     clientTextures(0)=Texture'DeusExUI.UserInterface.MenuMessageBoxBackground_1'
     clientTextures(1)=Texture'DeusExUI.UserInterface.MenuMessageBoxBackground_2'
     textureRows=1
     textureCols=2
     bActionButtonBarActive=True
     bUsesHelpWindow=False
     exitButtonText="Done"
     ScreenType=ST_Persona
}
